<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: PregelComputeManager&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classPregelComputeManager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PregelComputeManager&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comp__engine.html">Computation Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core Computation class for the Pregel engine it handles all the superstep processing including: vertex processing, message combining, aggregate information updating, and message distribution. it also handles the initialization procedure for all vertices. It is a template class that is parameterized by the following parameters.  
 <a href="classPregelComputeManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglEnginePregelComputeManager_8hpp_source.html">tiglEnginePregelComputeManager.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1be96ee44ecf6720e561e417fc6b9b31"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1be96ee44ecf6720e561e417fc6b9b31"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a1be96ee44ecf6720e561e417fc6b9b31">reset</a> ()</td></tr>
<tr class="memdesc:a1be96ee44ecf6720e561e417fc6b9b31"><td class="mdescLeft">&#160;</td><td class="mdescRight">reset the compute engine to return to the state before algorithm execution <br /></td></tr>
<tr class="separator:a1be96ee44ecf6720e561e417fc6b9b31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf9ef47f4e42ebc43ae5809ab567b71c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#adf9ef47f4e42ebc43ae5809ab567b71c">setDataManager</a> (DATA_CONTAINER_CLASS *dm)</td></tr>
<tr class="memdesc:adf9ef47f4e42ebc43ae5809ab567b71c"><td class="mdescLeft">&#160;</td><td class="mdescRight">setting the data manager pointer this has to be called before running graph algorithms  <a href="#adf9ef47f4e42ebc43ae5809ab567b71c">More...</a><br /></td></tr>
<tr class="separator:adf9ef47f4e42ebc43ae5809ab567b71c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad027e8f4df77653485cf5d48c13a2c4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#aad027e8f4df77653485cf5d48c13a2c4">setCombiner</a> (COMBINER_TYPE *cmb)</td></tr>
<tr class="memdesc:aad027e8f4df77653485cf5d48c13a2c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">setting the combiner pointer  <a href="#aad027e8f4df77653485cf5d48c13a2c4">More...</a><br /></td></tr>
<tr class="separator:aad027e8f4df77653485cf5d48c13a2c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59a41756c538939513884ca258de813e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a59a41756c538939513884ca258de813e">isInitialized</a> ()</td></tr>
<tr class="memdesc:a59a41756c538939513884ca258de813e"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if the object is properly initialized  <a href="#a59a41756c538939513884ca258de813e">More...</a><br /></td></tr>
<tr class="separator:a59a41756c538939513884ca258de813e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1d638dd4bb3c7a391da2e193d0e6303"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#ae1d638dd4bb3c7a391da2e193d0e6303">setMaxSS</a> (uint32 maxSSVal)</td></tr>
<tr class="memdesc:ae1d638dd4bb3c7a391da2e193d0e6303"><td class="mdescLeft">&#160;</td><td class="mdescRight">setting the maximum number of supersteps  <a href="#ae1d638dd4bb3c7a391da2e193d0e6303">More...</a><br /></td></tr>
<tr class="separator:ae1d638dd4bb3c7a391da2e193d0e6303"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e8fd4b9596624364ba8d8467238340d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a3e8fd4b9596624364ba8d8467238340d">processSystemMessages</a> (uint32 countSS)</td></tr>
<tr class="memdesc:a3e8fd4b9596624364ba8d8467238340d"><td class="mdescLeft">&#160;</td><td class="mdescRight">processing all system messages (this is executed at each superstep before processing data messages)  <a href="#a3e8fd4b9596624364ba8d8467238340d">More...</a><br /></td></tr>
<tr class="separator:a3e8fd4b9596624364ba8d8467238340d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af32133f0c1230e23cc07ed174aa31519"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#af32133f0c1230e23cc07ed174aa31519">init</a> (INIT_TYPE *initParams)</td></tr>
<tr class="memdesc:af32133f0c1230e23cc07ed174aa31519"><td class="mdescLeft">&#160;</td><td class="mdescRight">initialization procedure  <a href="#af32133f0c1230e23cc07ed174aa31519">More...</a><br /></td></tr>
<tr class="separator:af32133f0c1230e23cc07ed174aa31519"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3acd9047fc63ad9188dbd822f87dd398"><td class="memItemLeft" align="right" valign="top">SS_STATUS&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a3acd9047fc63ad9188dbd822f87dd398">superstep</a> (uint32 countSS)</td></tr>
<tr class="memdesc:a3acd9047fc63ad9188dbd822f87dd398"><td class="mdescLeft">&#160;</td><td class="mdescRight">core superstep computation procedure  <a href="#a3acd9047fc63ad9188dbd822f87dd398">More...</a><br /></td></tr>
<tr class="separator:a3acd9047fc63ad9188dbd822f87dd398"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a5f4ea263b1a6f25ef29b13a51f5eba"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4a5f4ea263b1a6f25ef29b13a51f5eba"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a4a5f4ea263b1a6f25ef29b13a51f5eba">getNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a4a5f4ea263b1a6f25ef29b13a51f5eba"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of output message <br /></td></tr>
<tr class="separator:a4a5f4ea263b1a6f25ef29b13a51f5eba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a139fee1e3f5571e78f6736bca52a7ccc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a139fee1e3f5571e78f6736bca52a7ccc"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a139fee1e3f5571e78f6736bca52a7ccc">getPastNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a139fee1e3f5571e78f6736bca52a7ccc"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of output message in the previous superstep <br /></td></tr>
<tr class="separator:a139fee1e3f5571e78f6736bca52a7ccc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6ddea236285a13721ee043242c6ae2a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac6ddea236285a13721ee043242c6ae2a"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#ac6ddea236285a13721ee043242c6ae2a">numActive</a> ()</td></tr>
<tr class="memdesc:ac6ddea236285a13721ee043242c6ae2a"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of active nodes for the device <br /></td></tr>
<tr class="separator:ac6ddea236285a13721ee043242c6ae2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d97b025cbfcc071daa8a592b8ee79d2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9d97b025cbfcc071daa8a592b8ee79d2"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a9d97b025cbfcc071daa8a592b8ee79d2">getNumIdleSysMessages</a> ()</td></tr>
<tr class="memdesc:a9d97b025cbfcc071daa8a592b8ee79d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of received idle system messages <br /></td></tr>
<tr class="separator:a9d97b025cbfcc071daa8a592b8ee79d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abebc4c1572672c51b90af452be5a2f68"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abebc4c1572672c51b90af452be5a2f68"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#abebc4c1572672c51b90af452be5a2f68">pushHaltMessage</a> ()</td></tr>
<tr class="memdesc:abebc4c1572672c51b90af452be5a2f68"><td class="mdescLeft">&#160;</td><td class="mdescRight">push a halt message into the sys message buffer <br /></td></tr>
<tr class="separator:abebc4c1572672c51b90af452be5a2f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab92afcd70437b1b183834d1d85767de9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab92afcd70437b1b183834d1d85767de9"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#ab92afcd70437b1b183834d1d85767de9">getNumHaltSysMessages</a> ()</td></tr>
<tr class="memdesc:ab92afcd70437b1b183834d1d85767de9"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of received halt system messages <br /></td></tr>
<tr class="separator:ab92afcd70437b1b183834d1d85767de9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a83055792bef2bc431014faa9a74d36c1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a83055792bef2bc431014faa9a74d36c1">distributeOutMessages</a> (LOCAL_MESSAGE_BUF &amp;outMessages, uint32 countSS)</td></tr>
<tr class="memdesc:a83055792bef2bc431014faa9a74d36c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">processing the output messages after each node processing and route them to appropriate internal or external message buffer  <a href="#a83055792bef2bc431014faa9a74d36c1">More...</a><br /></td></tr>
<tr class="separator:a83055792bef2bc431014faa9a74d36c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c00f7b17defb11a22e3d2d438af02b1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a3c00f7b17defb11a22e3d2d438af02b1">combineLocalMessages</a> (bool oddTimeFlag, bool externalFlag=false)</td></tr>
<tr class="memdesc:a3c00f7b17defb11a22e3d2d438af02b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">combining all the messages after finishing computing of all nodes and at the beginnning after receiving all new messages  <a href="#a3c00f7b17defb11a22e3d2d438af02b1">More...</a><br /></td></tr>
<tr class="separator:a3c00f7b17defb11a22e3d2d438af02b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b3b8cd385625916e495b633fc5aa551"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2b3b8cd385625916e495b633fc5aa551"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a2b3b8cd385625916e495b633fc5aa551">combineExternalOutMessages</a> ()</td></tr>
<tr class="memdesc:a2b3b8cd385625916e495b633fc5aa551"><td class="mdescLeft">&#160;</td><td class="mdescRight">combining external out messeages before MPI transfer <br /></td></tr>
<tr class="separator:a2b3b8cd385625916e495b633fc5aa551"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa67112d5a138f93b5a849b5e07cdbf7b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa67112d5a138f93b5a849b5e07cdbf7b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#aa67112d5a138f93b5a849b5e07cdbf7b">clearActiveBuffers</a> ()</td></tr>
<tr class="memdesc:aa67112d5a138f93b5a849b5e07cdbf7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">clearing the active buffer (this is called for each new superstep) <br /></td></tr>
<tr class="separator:aa67112d5a138f93b5a849b5e07cdbf7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a68666e57a6610ec64cf3f8de807f3600"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a68666e57a6610ec64cf3f8de807f3600">InsertActive</a> (uint32 pos)</td></tr>
<tr class="memdesc:a68666e57a6610ec64cf3f8de807f3600"><td class="mdescLeft">&#160;</td><td class="mdescRight">inserts a new vertex in the local active list  <a href="#a68666e57a6610ec64cf3f8de807f3600">More...</a><br /></td></tr>
<tr class="separator:a68666e57a6610ec64cf3f8de807f3600"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0ba1cc0c47eec7dc30e54f7da122fc6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#ab0ba1cc0c47eec7dc30e54f7da122fc6">RetreiveAndIncrement</a> (vector&lt; uint32 &gt;::iterator &amp;currActive, uint32 &amp;pos)</td></tr>
<tr class="memdesc:ab0ba1cc0c47eec7dc30e54f7da122fc6"><td class="mdescLeft">&#160;</td><td class="mdescRight">incrementing the active buffer list (with special handling for openMP)  <a href="#ab0ba1cc0c47eec7dc30e54f7da122fc6">More...</a><br /></td></tr>
<tr class="separator:ab0ba1cc0c47eec7dc30e54f7da122fc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc5600ca4635575f80a9925f20ec1b7e"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#adc5600ca4635575f80a9925f20ec1b7e">executeVertex</a> (VERTEX_ITERATOR itVertex, uint32 pos, bool oddTimeFlag, LOCAL_MESSAGE_BUF *outMessages)</td></tr>
<tr class="memdesc:adc5600ca4635575f80a9925f20ec1b7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">execute a single vertex during a super step: it reads the input messages and calls the compute function of the vertex  <a href="#adc5600ca4635575f80a9925f20ec1b7e">More...</a><br /></td></tr>
<tr class="separator:adc5600ca4635575f80a9925f20ec1b7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:abcf96a90bca976fb3a14dddafb69823c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abcf96a90bca976fb3a14dddafb69823c"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#abcf96a90bca976fb3a14dddafb69823c">maxSS</a></td></tr>
<tr class="memdesc:abcf96a90bca976fb3a14dddafb69823c"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the number of supersteps and the maximum number <br /></td></tr>
<tr class="separator:abcf96a90bca976fb3a14dddafb69823c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a180d699326ce23227ac4bd64deee10a4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a180d699326ce23227ac4bd64deee10a4"></a>
vector&lt; uint32 &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a180d699326ce23227ac4bd64deee10a4">activeList</a></td></tr>
<tr class="memdesc:a180d699326ce23227ac4bd64deee10a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the ID of the active vertex list <br /></td></tr>
<tr class="separator:a180d699326ce23227ac4bd64deee10a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44b1fde1e1f2eaa9f8b7aac93e98156a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a44b1fde1e1f2eaa9f8b7aac93e98156a"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a44b1fde1e1f2eaa9f8b7aac93e98156a">allActive</a></td></tr>
<tr class="memdesc:a44b1fde1e1f2eaa9f8b7aac93e98156a"><td class="mdescLeft">&#160;</td><td class="mdescRight">if enabled: all vertices are active all the time (terminated by max count) <br /></td></tr>
<tr class="separator:a44b1fde1e1f2eaa9f8b7aac93e98156a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe1b965ba349f73c05bd321b8823e94b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abe1b965ba349f73c05bd321b8823e94b"></a>
<a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; ALG_DATA_TYPE &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#abe1b965ba349f73c05bd321b8823e94b">aggregateInfo</a></td></tr>
<tr class="memdesc:abe1b965ba349f73c05bd321b8823e94b"><td class="mdescLeft">&#160;</td><td class="mdescRight">the aggregate information object <br /></td></tr>
<tr class="separator:abe1b965ba349f73c05bd321b8823e94b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a532bb706e3c58c25e479c3b75d4852"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1a532bb706e3c58c25e479c3b75d4852"></a>
DATA_CONTAINER_CLASS *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a1a532bb706e3c58c25e479c3b75d4852">dataManager</a></td></tr>
<tr class="memdesc:a1a532bb706e3c58c25e479c3b75d4852"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the data manager object <br /></td></tr>
<tr class="separator:a1a532bb706e3c58c25e479c3b75d4852"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fe0c6d2933cf1df8f2670b75d158986"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5fe0c6d2933cf1df8f2670b75d158986"></a>
COMBINER_TYPE *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a5fe0c6d2933cf1df8f2670b75d158986">combiner</a></td></tr>
<tr class="memdesc:a5fe0c6d2933cf1df8f2670b75d158986"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the data combiner object <br /></td></tr>
<tr class="separator:a5fe0c6d2933cf1df8f2670b75d158986"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9f3a3f8be3390fa71a53b145f288897"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad9f3a3f8be3390fa71a53b145f288897"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#ad9f3a3f8be3390fa71a53b145f288897">numIdleSysMessages</a></td></tr>
<tr class="memdesc:ad9f3a3f8be3390fa71a53b145f288897"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of idle system messages that are received. <br /></td></tr>
<tr class="separator:ad9f3a3f8be3390fa71a53b145f288897"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6630b764d6e95f2d7fb36a72fde08d7b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6630b764d6e95f2d7fb36a72fde08d7b"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelComputeManager.html#a6630b764d6e95f2d7fb36a72fde08d7b">numHaltSysMessages</a></td></tr>
<tr class="memdesc:a6630b764d6e95f2d7fb36a72fde08d7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of halt system messages that are received. <br /></td></tr>
<tr class="separator:a6630b764d6e95f2d7fb36a72fde08d7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DATA_CONTAINER_CLASS, typename COMBINER_TYPE, typename INIT_TYPE&gt;<br />
class PregelComputeManager&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;</h3>

<p>Core Computation class for the Pregel engine it handles all the superstep processing including: vertex processing, message combining, aggregate information updating, and message distribution. it also handles the initialization procedure for all vertices. It is a template class that is parameterized by the following parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DATA_CONTAINER_CLASS</td><td>the data manager class definition, </td></tr>
    <tr><td class="paramname">COMBINER_TYPE</td><td>the data combiner class definition, </td></tr>
    <tr><td class="paramname">INIT_TYPE</td><td>the definition of the init parameters of the graph algorithm </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a3c00f7b17defb11a22e3d2d438af02b1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::combineLocalMessages </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>oddTimeFlag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>externalFlag</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>combining all the messages after finishing computing of all nodes and at the beginnning after receiving all new messages </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oddTimeFlag</td><td>flag for the ping-poing buffer: true for odd SS, false for even S </td></tr>
    <tr><td class="paramname">externalFlag</td><td>false if the message is from local vertices, true if the messages are external </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a83055792bef2bc431014faa9a74d36c1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::distributeOutMessages </td>
          <td>(</td>
          <td class="paramtype">LOCAL_MESSAGE_BUF &amp;&#160;</td>
          <td class="paramname"><em>outMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>countSS</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>processing the output messages after each node processing and route them to appropriate internal or external message buffer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">outMessages</td><td>a buffer of messeages after a single vertex execution </td></tr>
    <tr><td class="paramname">countSS</td><td>the Superstep count </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adc5600ca4635575f80a9925f20ec1b7e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::executeVertex </td>
          <td>(</td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>itVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>oddTimeFlag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">LOCAL_MESSAGE_BUF *&#160;</td>
          <td class="paramname"><em>outMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>execute a single vertex during a super step: it reads the input messages and calls the compute function of the vertex </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itVertex</td><td>iterator to the current vertex in the vertices list </td></tr>
    <tr><td class="paramname">pos</td><td>position of the vartex (used for messages retrieval) </td></tr>
    <tr><td class="paramname">oddTimeFlag</td><td>flag for the ping-poing buffer: true for odd SS, false for even S </td></tr>
    <tr><td class="paramname">outMessages</td><td>buffers for the output messages after vertex execution</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of output messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af32133f0c1230e23cc07ed174aa31519"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::init </td>
          <td>(</td>
          <td class="paramtype">INIT_TYPE *&#160;</td>
          <td class="paramname"><em>initParams</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>initialization procedure </p>
<p>it is called once for each algorithm before executing the supersteps and it calls the init function for all vertices on the device.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">initParams</td><td>pointer to the initialization parameter of the graph algorithm </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a68666e57a6610ec64cf3f8de807f3600"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::InsertActive </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>pos</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>inserts a new vertex in the local active list </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pos</td><td>position of the active node in the vertices list </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a59a41756c538939513884ca258de813e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::isInitialized </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if the object is properly initialized </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if initialized, false otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3e8fd4b9596624364ba8d8467238340d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::processSystemMessages </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>countSS</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>processing all system messages (this is executed at each superstep before processing data messages) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">countSS</td><td>the current SS index </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab0ba1cc0c47eec7dc30e54f7da122fc6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::RetreiveAndIncrement </td>
          <td>(</td>
          <td class="paramtype">vector&lt; uint32 &gt;::iterator &amp;&#160;</td>
          <td class="paramname"><em>currActive</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32 &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>incrementing the active buffer list (with special handling for openMP) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">currActive</td><td>iterator to the current active vertex in the active list </td></tr>
    <tr><td class="paramname">pos</td><td>reference input in which the output value is inserted </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aad027e8f4df77653485cf5d48c13a2c4"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setCombiner </td>
          <td>(</td>
          <td class="paramtype">COMBINER_TYPE *&#160;</td>
          <td class="paramname"><em>cmb</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>setting the combiner pointer </p>
<p>this has to be called before running graph algorithms</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dm</td><td>pointer to the data combiner object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adf9ef47f4e42ebc43ae5809ab567b71c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setDataManager </td>
          <td>(</td>
          <td class="paramtype">DATA_CONTAINER_CLASS *&#160;</td>
          <td class="paramname"><em>dm</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>setting the data manager pointer this has to be called before running graph algorithms </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dm</td><td>pointer to the data manager object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae1d638dd4bb3c7a391da2e193d0e6303"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setMaxSS </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>maxSSVal</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>setting the maximum number of supersteps </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxSSVal</td><td>maximum possible number of supersteps </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3acd9047fc63ad9188dbd822f87dd398"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_CONTAINER_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">SS_STATUS <a class="el" href="classPregelComputeManager.html">PregelComputeManager</a>&lt; DATA_CONTAINER_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::superstep </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>countSS</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>core superstep computation procedure </p>
<p>it processes both system and data messages and route the output message to the appropriate buffers it also call the (algorithm-dependent) combiner function after processing all input messages</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">countSS</td><td>the current SS index </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>execution status, possible values are: SS_SUCCESS, NOT_INITIALIZED, VERTEX_NOT_FOUND, ALGORITHM_COMPLETED, MAX_SS_REACHED, </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/standard/engine/<a class="el" href="tiglEnginePregelComputeManager_8hpp_source.html">tiglEnginePregelComputeManager.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
